package org.xtext.example.mydsl.postprocessor

import org.eclipse.xtext.xtext.ecoreInference.IXtext2EcorePostProcessor
import org.eclipse.xtext.GeneratedMetamodel
import org.eclipse.emf.ecore.EPackage
import org.eclipse.emf.ecore.EClass
import org.xtext.example.mydsl.myDsl.VariableDefinition
import org.eclipse.emf.ecore.EcoreFactory
import org.eclipse.emf.ecore.EcorePackage

class MyXtext2EcorePostProcessor implements IXtext2EcorePostProcessor {
	
	override process(GeneratedMetamodel metamodel) {
		metamodel.EPackage.process
	}
	
	def process(EPackage p) {
		for (clazz : p.EClassifiers.filter(typeof(EClass))) {
	        if (clazz.name == typeof(VariableDefinition).simpleName) {
	            val typeAttribute = EcoreFactory::eINSTANCE.createEAttribute
		        typeAttribute.name = "type"
	            typeAttribute.EType = EcorePackage::eINSTANCE.EString
		        clazz.EStructuralFeatures += typeAttribute
	        }
	    }
	}
}