package org.xtext.example.mydsl.generator;

import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.IFileSystemAccess;
import org.eclipse.xtext.generator.IGenerator;
import org.xtext.example.mydsl.myDsl.DefinitionBlock;
import org.xtext.example.mydsl.myDsl.Method;
import org.xtext.example.mydsl.myDsl.Model;
import org.xtext.example.mydsl.myDsl.VariableDefinition;

@SuppressWarnings("all")
public class MyDslGenerator implements IGenerator {
  public void doGenerate(final Resource resource, final IFileSystemAccess fsa) {
    EList<EObject> _contents = resource.getContents();
    Iterable<Model> _filter = Iterables.<Model>filter(_contents, Model.class);
    CharSequence _generate = this.generate(_filter);
    fsa.generateFile("variables.txt", _generate);
  }
  
  public CharSequence generate(final Iterable<Model> models) {
    StringConcatenation _builder = new StringConcatenation();
    {
      for(final Model model : models) {
        {
          EList<Method> _methods = model.getMethods();
          for(final Method method : _methods) {
            _builder.append("Method: ");
            String _name = method.getName();
            _builder.append(_name, "");
            _builder.newLineIfNotEmpty();
            {
              EList<DefinitionBlock> _definitionBlocks = method.getDefinitionBlocks();
              for(final DefinitionBlock definitionBlock : _definitionBlocks) {
                {
                  EList<VariableDefinition> _variableDefinitions = definitionBlock.getVariableDefinitions();
                  for(final VariableDefinition variableDefinition : _variableDefinitions) {
                    _builder.append("- ");
                    CharSequence _generate = this.generate(variableDefinition);
                    _builder.append(_generate, "");
                    _builder.newLineIfNotEmpty();
                  }
                }
              }
            }
          }
        }
      }
    }
    return _builder;
  }
  
  public CharSequence generate(final VariableDefinition variableDefinition) {
    StringConcatenation _builder = new StringConcatenation();
    String _name = variableDefinition.getName();
    _builder.append(_name, "");
    _builder.append(" : ");
    String _type = variableDefinition.getType();
    _builder.append(_type, "");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
}
