package org.xtext.example.mydsl.postprocessor;

import com.google.common.collect.Iterators;
import java.util.Iterator;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.resource.DerivedStateAwareResource;
import org.eclipse.xtext.resource.IDerivedStateComputer;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;
import org.xtext.example.mydsl.myDsl.DefinitionBlock;
import org.xtext.example.mydsl.myDsl.VariableDefinition;

@SuppressWarnings("all")
public class MyDerivedStateComputer implements IDerivedStateComputer {
  public void discardDerivedState(final DerivedStateAwareResource resource) {
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterator<VariableDefinition> _filter = Iterators.<VariableDefinition>filter(_allContents, VariableDefinition.class);
    final Procedure1<VariableDefinition> _function = new Procedure1<VariableDefinition>() {
        public void apply(final VariableDefinition it) {
          it.setType(null);
        }
      };
    IteratorExtensions.<VariableDefinition>forEach(_filter, _function);
  }
  
  public void installDerivedState(final DerivedStateAwareResource resource, final boolean preLinkingPhase) {
    TreeIterator<EObject> _allContents = resource.getAllContents();
    Iterator<VariableDefinition> _filter = Iterators.<VariableDefinition>filter(_allContents, VariableDefinition.class);
    final Procedure1<VariableDefinition> _function = new Procedure1<VariableDefinition>() {
        public void apply(final VariableDefinition it) {
          EObject _eContainer = it.eContainer();
          String _type = ((DefinitionBlock) _eContainer).getType();
          it.setType(_type);
        }
      };
    IteratorExtensions.<VariableDefinition>forEach(_filter, _function);
  }
}
