package org.xtext.example.mydsl.postprocessor;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcoreFactory;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.xtext.GeneratedMetamodel;
import org.eclipse.xtext.xtext.ecoreInference.IXtext2EcorePostProcessor;
import org.xtext.example.mydsl.myDsl.VariableDefinition;

@SuppressWarnings("all")
public class MyXtext2EcorePostProcessor implements IXtext2EcorePostProcessor {
  public void process(final GeneratedMetamodel metamodel) {
    EPackage _ePackage = metamodel.getEPackage();
    this.process(_ePackage);
  }
  
  public void process(final EPackage p) {
    EList<EClassifier> _eClassifiers = p.getEClassifiers();
    Iterable<EClass> _filter = Iterables.<EClass>filter(_eClassifiers, EClass.class);
    for (final EClass clazz : _filter) {
      String _name = clazz.getName();
      String _simpleName = VariableDefinition.class.getSimpleName();
      boolean _equals = Objects.equal(_name, _simpleName);
      if (_equals) {
        final EAttribute typeAttribute = EcoreFactory.eINSTANCE.createEAttribute();
        typeAttribute.setName("type");
        EDataType _eString = EcorePackage.eINSTANCE.getEString();
        typeAttribute.setEType(_eString);
        EList<EStructuralFeature> _eStructuralFeatures = clazz.getEStructuralFeatures();
        _eStructuralFeatures.add(typeAttribute);
      }
    }
  }
}
